options ls=80 ps=60 nocenter;

/* rerun: 4-97 for ema 2nd round

   NAGG1Z82: for 82-83 conversion

   MAKES SAVE.FOURZ82

   program aggZ -- aggregate and average ZEROs across years
   produces 6-year average earnings and variance

   written 23.1.96  
   revised june 2, 1997*/


* libname save '/bbkinghome/sschaner/Angrist Work/Web Papers/Angrist_1998/SAS data/';
* libname save '/data/angrist/asvab/save';


data one;
set save.ssaone;

if ((transyy ge 79) and (edgrp ne 10) and (2<=afqtgrp<=6)
   and (83<=year<=83));


if zerovar ne . then pzero=zerovar/samcount;
   else pzero=.;

earnvar=pzero;
sigma2=(pzero*(1-pzero))/SAMcount;

if (pzero ne .) ;

***> correlation sequence;

data d83;
set one;

 if year=83 then output d83;

data d83; set d83; y83=earnvar; s83=sigma2; n83=SAMcount; p83=POPcount;
   matchvar=_n_;
   keep dnwhite edgrp dobyy transyy afqtgrp dvet y83 s83 n83 p83 matchvar;

data wide;
 set d83;

 *if (0<y82<1) and (0<y83<1);
 **> for comp w yearly;

proc sort data=wide; by dnwhite;
proc corr data=wide outp=corrmtx;
var y83;
by dnwhite;

data corrmtx;
  set corrmtx;
  if _type_ eq 'CORR';
  if (_name_ eq 'Y83'| _name_ eq 'y83') then year=83;
  keep dnwhite year y83;

proc print data=corrmtx;
title 'corr matrix by race for 83 earnings';

**************** WHITES *******************;

 data wide_w; set wide; if dnwhite=0;
 data mtx_w; set corrmtx; if dnwhite=0;

 proc iml;

 use wide_w;
 read all var{ y83} into Y;
 read all var{ s83} into S;
 read all var{ n83} into P;
 close wide_w;

 use mtx_w;
 read all var{ y83} into corr;
 close mtx_w;

 s=s##.5;

 nobs=nrow(y);

 mean=j(nobs,1,0);
 rs=j(1,1,0);
 covmtx=j(1,1,0);
 avgvar=j(nobs,1,0);
 weights=j(1,1,0);

 /* loop to compute average earnings and variance */

 do i=1 to nobs;

   weights=P[i,]/P[i,+];
   mean[i]=weights*Y[i,]`;

   rs=S[i,]`;
   covmtx=diag(rs)*corr*diag(rs);

   avgvar[i]=weights*covmtx*weights`;

   end;

   results = mean||avgvar;
   varnames={'pooly' 'poolvar'};

create threew from results [colname=varnames];
append from results;


************ NONWHITES ******************;

 data wide_n; set wide; if dnwhite=1;
 data mtx_n; set corrmtx; if dnwhite=1;

 proc iml;

 use wide_n;
 read all var{ y83} into Y;
 read all var{ s83} into S;
 read all var{ n83} into P;
 close wide_n;

 use mtx_n;
 read all var{ y83} into corr;
 close mtx_n;

 s=s##.5;

 nobs=nrow(y);

 mean=j(nobs,1,0);
 rs=j(1,1,0);
 covmtx=j(1,1,0);
 avgvar=j(nobs,1,0);
 weights=j(1,1,0);

 /* loop to compute average earnings and variance */

 do i=1 to nobs;

   weights=P[i,]/P[i,+];
   mean[i]=weights*Y[i,]`;

   rs=S[i,]`;
   covmtx=diag(rs)*corr*diag(rs);

   avgvar[i]=weights*covmtx*weights`;

   end;

   results = mean||avgvar;
   varnames={'pooly' 'poolvar'};

create threen from results [colname=varnames];
append from results;


/* put average and variance back on wide ds */

data three;
 set threew(in=inw) threen;
 if inw=1 then dnwhite=0; else dnwhite=1;
 matchvar=_n_;

proc sort data=wide; by matchvar;
data save.fourZ82_sgs;
 merge wide three;
 by matchvar;

 poolsam=n83;
 poolpop=p83;

 poolsig2=poolvar*poolsam;     **> same as orig. progs;

proc sort data=save.fourZ82_sgs; by dnwhite;
proc means data=save.fourZ82_sgs;
by dnwhite;
run;







