
options ls=80 ps=60 nocenter; title; footnote;
goptions cback=white csymbol=black cby=black device=win; *device=hpljs3;

/* rerun: 4-97 for ema 2nd round

   NAGG2Z: MUST RUN NAGG1Z FIRST

   88-91

   january 24, 1996

   AGG2Z: step two of pooled estimation for ZEROS (from emarev3)


   mitiv32c.sas:  written 6-28-95
                 saturated setting for EARLYLOW

                 revised to use GLMMOD for covariates

                 CORRECTED to produce instrument-level aggregate
                 statistics

                 continues TSLS sequence

                 Revised figure 12  7-5-95
                 to correct scale and make hardcopy of plotted data

                 7-6-95 tries saturated first with constant t.e        */


* libname save '/bbkinghome/sschaner/Angrist Work/Web Papers/Angrist_1998/SAS data/';
* libname save '/data/angrist/asvab/save';

   Data one;
   set save.fourZ;

   POPcount=poolPOP; drop poolPOP;
   SAMcount=poolSAM; drop poolSAM;

   rate=SAMcount/POPcount;  **> pooled sam and popcounts;
   sigma2=poolsig2/rate;    **> poolsig2 is pooled cell variance;

   earnvar=pooly;

   year=8891;

**> aggregate to level of instruments;

proc sort data=one;
by dnwhite year edgrp dobyy transyy afqtgrp;

proc summary data=one;
FREQ POPcount;
var earnvar sigma2 dvet y88-y91;
output out=one mean=earnvar sigma2 vethat y88-y91 n=AGGcount;
by dnwhite year edgrp dobyy transyy afqtgrp;


data one; set one;
trackyy=transyy;
if sigma2>0 then WTvar = AGGcount/sigma2;

 ** saturated regression model except transyy--aftqgrp **;

proc glmmod data=one outparm=parms outdesign=design noprint;
weight WTvar;
class edgrp dobyy transyy afqtgrp ;
model earnvar =
      dnwhite year edgrp*dobyy*transyy edgrp*dobyy*afqtgrp trackyy
      AGGcount vethat y88-y91;
run;


proc datasets; delete one;

  data design; set design;
      dnwhite=col2; drop col2;
      year=col3; drop col3;
      transyy=col330; drop col330;
      AGGcount=col331; drop col331;
      vethat=col332; drop col332;

 if (0<col333<1) and (0<col334<1) and (0<col335<1) and (0<col336<1);

  proc reg data=design outest=three covout noprint;
  weight WTvar;
  model earnvar=col4-col329 vethat;
  by dnwhite year;

data three; set three;
if (_type_ eq 'PARMS') or ((_type_ eq 'COV') and (_name_ eq 'vethat'));
if (_type_ eq 'COV') then vethat = sqrt(vethat)/_rmse_;

keep dnwhite year _type_ _name_ vethat _rmse_;

proc print data=three; run;
