options ls=80 ps=60 nocenter; title; footnote;
goptions cback=white csymbol=black cby=black device=hpljs2; * device=win;

/* mittabl4a.sas: revised 29.12.95 covalpha.sas
   cov of regn alpha and SATE 


   rerun: 4-97 for ema 2nd round 
   NAGG482.SAS for pooled estimates  
   84-87 
   
   revised june 2, 1997*/

* libname indat '/bbkinghome/sschaner/Angrist Work/Web Papers/Angrist_1998/SAS data/';


Data vets nonvets;
set indat.four82_sgs;

** code aggregates to match other programs **;

POPcount=poolPOP; drop poolPOP;
SAMcount=poolSAM; drop poolSAM;
rate=SAMcount/POPcount;
sigma2=poolsig2;
earnvar=pooly;

year=83;

** end **;

If (transyy ge 79) and (edgrp ne 10) and (2<=afqtgrp<=6);

** sigma2=stdvar**2; 

if earnvar ne . and sigma2 ne .;

if dvet=1 then output vets;
if dvet=0 then output nonvets;


data vets; set vets;

numvets=popcount;
samvets=samcount;
ratevet=samcount/popcount;

vetern=earnvar;
veternl=logvar;
vsigma2 = sigma2;

keep numvets samvets vetern veternl year dnwhite transyy afqtgrp edgrp
     dobyy ratevet vsigma2;


data nonvets; set nonvets;

numnon=popcount;
samnon=samcount;
ratenon=samcount/popcount;

nonern=earnvar;
nonernl=logvar;
nsigma2 = sigma2;

keep numnon samnon nonern nonernl year dnwhite transyy afqtgrp edgrp
     dobyy ratenon nsigma2;

 proc sort data=vets;
 by dnwhite year transyy afqtgrp edgrp dobyy;

 proc sort data=nonvets;
 by dnwhite year transyy afqtgrp edgrp dobyy;

data two;
 merge vets nonvets;
 by dnwhite year transyy afqtgrp edgrp dobyy;
 flag1=((samvets=0) or (samvets=.));  flag2=((samnon=0) or (samnon=.));
 flag3=((posvets=0) or (posvets=.));  flag4=((posnon=0) or (posnon=.));

     data two; set two;
     if ((flag1=0) and (flag2=0));   ***> drop nonoverlapping cells;

proc summary data=two ;
var numvets numnon;
output out=totals sum= totvets totnon;
by dnwhite year;
proc print data=totals;

     data two; 
     merge two totals;
     by dnwhite year;

     Xeffect = vetern-nonern;
     Xvar = (vsigma2/samvets)+(nsigma2/samnon);

     pvet = numvets/(numvets+numnon);

        /*   if dnwhite=0 then do; totvets=428820; totnon=409827; end;
             else if dnwhite=1 then do; totvets=187594; totnon=201588; end; */

     total=totvets+totnon;

        /*  base_r = (dnwhite*.2006976)+((1-dnwhite)*.2185623); */

     base_r = (totvets/total)*(1-(totvets/total));

     wt_c = pvet*((numvets+numnon)/totvets);
     wt_r = pvet*(1-pvet)*((numvets+numnon)/total)*(1/base_r);

     XvarC = Xvar*wt_c;
     XvarR = Xvar*wt_r;

     covterm=Xvar*wt_c*wt_r;

proc sort data=two;
by dnwhite year;


proc summary data=two;
var Xeffect XvarC;
weight wt_c;
*freq numvets;
output out=threeC mean=alphac varc;
by dnwhite year;

proc summary data=two;
var Xeffect XvarR;
weight wt_r;
output out=threeR mean=alphar varr ;
by dnwhite year;

proc summary data=two;                **> cov is Sum(product wts times Xvar);
var covterm;
output out=four sum=covterm;
by dnwhite year;                

data three;
merge threeC threeR four;
by dnwhite year;
if dnwhite=1 then race='Nonwhite';
if dnwhite=0 then race='White';   drop dnwhite;

se_c = sqrt(varc); se_r = sqrt(varr);

dif=alphac-alphar;
se_dif = (varc+varr-(2*covterm))**.5;

proc print data=three noobs round;
format alphac se_c alphar se_r dif se_dif 8.1;
var race year alphac se_c alphar se_r dif se_dif;
run;
