options ls=80 nocenter; title; footnote;
goptions cback=white csymbol=black cby=black device=hpljs2; * device=win;

/* mittabl4a.sas: matches on covariates for SATE

  run 4-97 for ema second round

  NOW: NAGG584.SAS UNCONTROLLED FOR POOLED

  **** revised 25-11-95 for ema as TABL4REV     ****
  **** confirm table4 -- all earnings           ****

   revised for *** Table 4a *** ALL earnings *** on vet-non contrast
   revised to add means 6-15-95 

   84-87

*/


* libname indat '/bbkinghome/sschaner/Angrist Work/Web Papers/Angrist_1998/SAS data/';
* libname indat '/data/angrist/asvab/save';

Data vets nonvets;
set indat.FOUR84;

If (transyy ge 79) and (edgrp ne 10) and (2<=afqtgrp<=6);

year=8487;

POPcount=poolPOP; drop poolPOP;
SAMcount=poolSAM; drop poolSAM;
sigma2=poolsig2;  drop poolsig2;
earnvar=pooly;    drop pooly;

/* sigma2=stdvar**2;
   sigma2p=sdposvar**2; */

if dvet=1 then output vets;
if dvet=0 then output nonvets;


data vets; set vets;

numvets=popcount;
samvets=samcount;
ratevet=samcount/popcount;
posvets=(samcount-zerovar)/ratevet;

vetern=earnvar;
veternp=posvar;
veternl=logvar;
vsigma2=sigma2/ratevet;
vsigma2p=sigma2p/ratevet;

keep numvets samvets vetern veternl year dnwhite transyy afqtgrp edgrp
     dobyy posvets veternp vsigma2 vsigma2p ratevet;


data nonvets; set nonvets;

numnon=popcount;
samnon=samcount;
ratenon=samcount/popcount;
posnon=(samcount-zerovar)/ratenon;

nonern=earnvar;
nonernp=posvar;
nonernl=logvar;
nsigma2=sigma2/ratenon;
nsigma2p=sigma2p/ratenon;

keep numnon samnon nonern nonernl year dnwhite transyy afqtgrp edgrp
     dobyy posnon nonernp nsigma2 nsigma2p ratenon;

 proc sort data=vets;
 by year dnwhite transyy afqtgrp edgrp dobyy;

 proc sort data=nonvets;
 by year dnwhite transyy afqtgrp edgrp dobyy;

data two;
 merge vets nonvets;
 by year dnwhite transyy afqtgrp edgrp dobyy;
 flag1=((samvets=0) or (samvets=.));  flag2=((samnon=0) or (samnon=.));
 flag3=((posvets=0) or (posvets=.));  flag4=((posnon=0) or (posnon=.));

  /* data two; set two;
     if ((flag1=0) and (flag2=0));   ***> drop nonoverlapping cells;   */

proc summary data=two;
var vetern vsigma2;
freq numvets;
output out=threev mean= n=n_vets;
by year dnwhite ;

proc summary data=two;
var nonern nsigma2;
freq numnon;
output out=threec1 mean= n=n_non;
by year dnwhite ;

data three;
merge threev threec1 ;
by year dnwhite ;
if dnwhite=1 then race='Nonwhite';
if dnwhite=0 then race='White';

effect=vetern-nonern;
stderr=((vsigma2/n_vets) + (nsigma2/n_non))**.5;
mean=((vetern*n_vets)+(nonern*n_non))/(n_vets+n_non);


data white nonwhite;
set three;
if dnwhite=0 then output white;
if dnwhite=1 then output nonwhite;

data nonwhite; set nonwhite;
nmean=mean; neffect=effect; nstderr=stderr;
keep year nmean neffect nstderr;

data three; merge white nonwhite; by year;

proc print data=three noobs round double;
format mean effect stderr nmean neffect nstderr 8.1;
var year mean effect stderr
         nmean neffect nstderr;

title1 'veteran-nonveteran effects by year and race';
title2 'weighted by population cell counts';

run;
