options ls=80 ps=60 nocenter; title; footnote;
goptions cback=white csymbol=black cby=black device=hpljs2; * device=win;

/* mittabl4a.sas: matches on covariates for SATE

  **** revised 25-11-95 for ema as TABL4ZER     ****
  **** revise Table4 to include P(ZERO)         ****

   revised for *** Table 4a *** ALL earnings *** on vet-non contrast
   revised to add means 6-15-95 


   rerun 4-97 for ema 2nd round 

   NOW: NAGG5Z82.SAS UNCONTROLLED FOR POOLED 

   revised june 3, 1997

   82-83  
*/


* libname indat '/bbkinghome/sschaner/Angrist Work/Web Papers/Angrist_1998/SAS data/';
* libname indat '/data/angrist/asvab/save';

Data vets nonvets;
set indat.fourz82_sgs;

If (transyy ge 79) and (edgrp ne 10) and (2<=afqtgrp<=6);

year=8283;

POPcount=poolPOP;   drop poolPOP;
SAMcount=poolSAM;   drop poolSAM;
sigma2Z=poolsig2;   drop poolsig2;
pzero=pooly;        drop pooly;

/* sigma2=stdvar**2;
   sigma2p=sdposvar**2;

   if zerovar ne . then pzero = zerovar/samcount;
     else pzero=.;

   sigma2z=(pzero*(1-pzero)); */


if pzero ne .;                    **> corrected 4-97;

if dvet=1 then output vets;
if dvet=0 then output nonvets;


data vets; set vets;

numvets=popcount;
samvets=samcount;
ratevet=samcount/popcount;
posvets=(samcount-zerovar)/ratevet;

vetzero=pzero;

vetern=earnvar;
veternp=posvar;
veternl=logvar;

vsigma2z=sigma2z/ratevet;

vsigma2=sigma2/ratevet;
vsigma2p=sigma2p/ratevet;

keep numvets samvets vetern veternl year dnwhite transyy afqtgrp edgrp
     dobyy posvets veternp vsigma2 vsigma2p ratevet vetzero vsigma2z;


data nonvets; set nonvets;

numnon=popcount;
samnon=samcount;
ratenon=samcount/popcount;
posnon=(samcount-zerovar)/ratenon;

nonzero=pzero;

nonern=earnvar;
nonernp=posvar;
nonernl=logvar;

nsigma2z=sigma2z/ratenon;

nsigma2=sigma2/ratenon;
nsigma2p=sigma2p/ratenon;

keep numnon samnon nonern nonernl year dnwhite transyy afqtgrp edgrp
     dobyy posnon nonernp nsigma2 nsigma2p ratenon nonzero nsigma2z;

 proc sort data=vets;
 by year dnwhite transyy afqtgrp edgrp dobyy;

 proc sort data=nonvets;
 by year dnwhite transyy afqtgrp edgrp dobyy;

data two;
 merge vets nonvets;
 by year dnwhite transyy afqtgrp edgrp dobyy;
 flag1=((samvets=0) or (samvets=.));  flag2=((samnon=0) or (samnon=.));
 flag3=((posvets=0) or (posvets=.));  flag4=((posnon=0) or (posnon=.));

  /* data two; set two;
     if ((flag1=0) and (flag2=0));   ***> drop nonoverlapping cells;   */

proc summary data=two;
var vetzero vsigma2z;
freq numvets;
output out=threev  mean=vetern vsigma2 n=n_vets;
by year dnwhite ;

proc summary data=two;
var nonzero nsigma2z;
freq numnon;
output out=threec1 mean=nonern nsigma2 n=n_non;
by year dnwhite ;

data three;
merge threev threec1 ;
by year dnwhite ;
if dnwhite=1 then race='Nonwhite';
if dnwhite=0 then race='White';

effect=vetern-nonern;
stderr=((vsigma2/n_vets) + (nsigma2/n_non))**.5;
mean=((vetern*n_vets)+(nonern*n_non))/(n_vets+n_non);


data white nonwhite;
set three;
if dnwhite=0 then output white;
if dnwhite=1 then output nonwhite;

data nonwhite; set nonwhite;
nmean=mean; neffect=effect; nstderr=stderr;
keep year nmean neffect nstderr;

data three4z; merge white nonwhite; by year;

proc print data=three4z noobs round double;
format mean effect stderr nmean neffect nstderr 5.4;
var year mean effect stderr
         nmean neffect nstderr;

title1 'veteran-nonveteran effects by year and race: p(zero)';
title2 'weighted by population cell counts';

run;








